/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner 
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/SQL/Extract_referenced_GenTables.sql $
$Rev: 15074 $
$Date: 2020-04-16 16:24:08 -0500 (Thu, 16 Apr 2020) $
***************************************************************************************************/
-- This is an adhoc script for extracting the CCW information and the related Gen_Tables data
-- The output is a SQL script which can be run in another database

exec pr_wv_SortCCW
go
set nocount on
go

select '-- Config_Custom_Web
-- server ' + @@servername + '
-- database ' + db_name() + '
-- date ' + convert(varchar, getdate()) + '

declare @id varchar(10), @seqnoffset int
select @id = ID from dbo.Name where MEMBER_TYPE = ''_CFG''
select @seqnoffset = max(SEQN) from dbo.Config_Custom_Web where ID = @id

INSERT INTO Config_Custom_Web (SEQN, ID, DEMOG_TABLE_NAME, FIELD_NAME, FIELD_REQUIRED, CUSTOM_CSS, DEFAULT_VALUE_FUNCTION,
	DESCRIPTION_BEFORE, DESCRIPTION_AFTER, PAGEPART, PROMPT, SHOW_IN_GRID, SORT_POSITION, ROLES_REQUIRED_EDIT,
	ROLES_REQUIRED_EDIT_NEW, ROLES_REQUIRED_VIEW, ROLES_REQUIRED_VIEW_NEW, TOOLTIP, VALIDATION_TABLE, VALIDATION_TYPE,
	ALLOW_MARKUP, RANGE_MINIMUM, RANGE_MAXIMUM, NUMERIC_INCREMENT, SELECTOR_SINGLE, SELECTOR_PARENT)
values'

select '(@seqnoffset + '
		+ convert(varchar(10), row_number() over (order by SEQN)) 
		+ ', @id, '''
		+ DEMOG_TABLE_NAME + ''', ''' 
		+ FIELD_NAME + ''', ' 
		+ convert(varchar, FIELD_REQUIRED) + ', '''
		+ CUSTOM_CSS + ''', '''
		+ DEFAULT_VALUE_FUNCTION + ''', '''
		+ replace(isnull(convert(varchar(max), DESCRIPTION_BEFORE), ''), '''', '''''') + ''', ''' 
		+ replace(isnull(convert(varchar(max), DESCRIPTION_AFTER), ''), '''', '''''') + ''', '''
		+ PAGEPART + ''', ''' 
		+ replace(PROMPT, '''', '''''') + ''', ' 
		+ convert(varchar, SHOW_IN_GRID) + ', ' 
		+ convert(varchar, SORT_POSITION) + ', ''' 
		+ ROLES_REQUIRED_EDIT + ''', ''' 
		+ ROLES_REQUIRED_EDIT_NEW + ''', ''' 
		+ ROLES_REQUIRED_VIEW + ''', ''' 
		+ ROLES_REQUIRED_VIEW_NEW + ''', ''' 
		+ replace(TOOLTIP, '''', '''''') + ''', ''' 
		+ VALIDATION_TABLE + ''', ''' 
		+ VALIDATION_TYPE + ''', '
		+ convert(varchar,ALLOW_MARKUP) + ', '''
		+ convert(varchar,RANGE_MINIMUM) + ''', '''
		+ convert(varchar,RANGE_MAXIMUM) + ''', '
		+ convert(varchar,NUMERIC_INCREMENT) + ', '''
		+ replace(SELECTOR_SINGLE, '''', '''''') + ''', '''
		+ replace(SELECTOR_PARENT, '''', '''''') 
		+ '''),'
	from dbo.Config_Custom_Web
	order by SEQN

print ''
print '-- Rows were inserted without use of Counter table, so sort now.'
print 'exec dbo.pr_wv_SortCCW'
go

select 'insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION) select ''' + TABLE_NAME + ''', ''' + CODE + ''', ''' + UPPER_CODE + ''', ''' + SUBSTITUTE + ''', ''' + replace(DESCRIPTION, '''', '''''') + ''' where not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = ''' + TABLE_NAME + ''' and CODE = ''' + CODE + ''');
go'
	from dbo.Gen_Tables
	where TABLE_NAME in (select distinct VALIDATION_TABLE from dbo.Config_Custom_Web where VALIDATION_TYPE = 'GENTABLE')
		or TABLE_NAME in ('CCW_PAGEPART', 'CCW_PAGEPRIMARYTABLE', 'CCW_SUBMISSION_STATUS_ACCESS')
		or TABLE_NAME in (select distinct VALIDATION_TABLE from dbo.UD_Field where VALIDATION_TABLE != '' and TABLE_NAME = 'Config_Custom_Web')
		or TABLE_NAME in (select distinct VALIDATION_TABLE from dbo.UD_Field where VALIDATION_TABLE != '' and TABLE_NAME in (select distinct DEMOG_TABLE_NAME from dbo.Config_Custom_Web where VALIDATION_TYPE = 'GENTABLE'))
	order by TABLE_NAME, CODE
