/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
-- Procedures, functions, views, including CLR functions

print @@servername + ':' + db_name() + ' - starting at ' + convert(varchar(30), getdate(), 109);
print '';
go
set nocount on;
go

print '-- fr_wv_SeqnToSelector';
go
create function fr_wv_SeqnToSelector
	(@seqn int, @pagePart nvarchar(30))
	returns nvarchar(50)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.fr_wv_SeqnToSelector;
go
grant execute, references, view definition on dbo.fr_wv_SeqnToSelector to IMIS;
go

print '-- fr_wv_SelectorToSeqn';
go
create function fr_wv_SelectorToSeqn
	(@selector nvarchar(50), @pagePart nvarchar(30), @imisId nvarchar(10))
	returns int
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.fr_wv_SelectorToSeqn;
go
grant execute, references, view definition on dbo.fr_wv_SelectorToSeqn to IMIS;
go


print '-- fr_wv_AssemblyFileVersion';
go
create function fr_wv_AssemblyFileVersion
	()
	returns nvarchar(255)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.AssemblyFileVersion;
go
grant execute, references, view definition on dbo.fr_wv_AssemblyFileVersion to IMIS;
go


print '-- fr_wv_AssemblyDescription';
go
create function fr_wv_AssemblyDescription
	()
	returns nvarchar(255)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
external name RSMSQLCLR.UserDefinedFunctions.AssemblyDescription;
go
grant execute, references, view definition on dbo.fr_wv_AssemblyDescription to IMIS;
go


print 'Creating Transact-SQL objects';
go

print '-- fr_ListToRows';
go
if object_id('fr_ListToRows') is NULL
begin
	exec ('create /* model */ function fr_ListToRows() returns @out table (x int) as begin return; end;')
end;
go
alter function fr_ListToRows
	(@sCommaString varchar(8000))
	returns @tReturn table (VALUE varchar(255))
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	declare @sValue varchar(255),
		@lPos int;

	while @sCommaString > ''
	begin
		set @lPos = charindex(',', @sCommaString);

		if @lPos > 0
		begin
			set @sValue = substring(@sCommaString, 1, @lPos - 1);
			set @sCommaString = substring(@sCommaString, @lPos + 1, len(@sCommaString));
		end
		else
		begin
			set @sValue = @sCommaString;
			set @sCommaString = '';
		end;

		if not exists (select 1 from @tReturn where VALUE = @sValue)
		begin
			insert @tReturn (VALUE)
				values (@sValue);
		end;
	end;

	return;
end;
go
grant select on dbo.fr_ListToRows to public;
go


print '-- fr_BeforeDelimiter';
go
if object_id('fr_BeforeDelimiter') is NULL
begin
	exec ('create /* model */ function fr_BeforeDelimiter() returns int as begin return 1; end;');
end;
go
alter function fr_BeforeDelimiter
	(@sString varchar(255),
	@sDelimiter char(1)) 
	returns varchar(255)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	declare @sReturn as varchar(255),
		@lPos as int;

	set @lPos = charindex(@sDelimiter, @sString);
	if @lPos > 0
	begin
		set @sReturn = left(@sString, @lPos - 1);
	end
	else
	begin
		set @sReturn = @sString;
	end;

	return @sReturn;
end;
go
grant execute on dbo.fr_BeforeDelimiter to public;
go


if object_id('fr_wv_UserCanEditRecord') is not NULL
begin
	print '-- Deleting obsolete fr_wv_UserCanEditRecord';
	drop function fr_wv_UserCanEditRecord;
end;
go


print '-- fr_CCWCalc_TemporaryPlaceholder';
go
if object_id('fr_CCWCalc_TemporaryPlaceholder') is NULL
begin
	exec ('create /* model */ function fr_CCWCalc_TemporaryPlaceholder() returns int as begin return 1; end;');
end;
go
alter function fr_CCWCalc_TemporaryPlaceholder
	(@plSeqn int)
	returns int
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
-- This function is a placeholder until the appropriate function is written
begin
	declare @lReturn int;

	set @lReturn = -2000000000;

	return @lReturn;
end;
go
grant execute, references, view definition on fr_CCWCalc_TemporaryPlaceholder to IMIS;
go


print '-- fr_wv_PagePrimaryTable';
go
if object_id('fr_wv_PagePrimaryTable') is NULL
begin
	exec ('create /* model */ function fr_wv_PagePrimaryTable() returns int as begin return 1; end;');
end;
go
alter function fr_wv_PagePrimaryTable
	(@pagePart varchar(30))
	returns varchar(30)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	declare @udt varchar(30),
		@page varchar(30);

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	select @udt = gt.SUBSTITUTE
		from dbo.Gen_Tables gt
		join dbo.UD_Field uf
			on uf.TABLE_NAME = gt.SUBSTITUTE
		where gt.TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			and gt.CODE = @page
			and uf.FIELD_NAME = 'SELECTOR_SINGLE';

	if @@rowcount = 0
	begin
		select @udt = gt.SUBSTITUTE
			from dbo.Gen_Tables gt
			where gt.TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
				and gt.CODE = @page
				and gt.SUBSTITUTE not in (select TABLE_NAME from dbo.UD_Field uf where FIELD_NAME = 'SELECTOR_SINGLE');
	end;

	return @udt;
end;
go
grant execute, references, view definition on dbo.fr_wv_PagePrimaryTable to IMIS;
grant execute, references, view definition on dbo.fr_wv_PagePrimaryTable to public;
go


print '-- pr_wv_SortCCW';
go
if object_id('pr_wv_SortCCW') is NULL
begin
	exec ('create /* model */ procedure pr_wv_SortCCW as set nocount on;');
end;
go
alter procedure pr_wv_SortCCW
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set nocount on;

	declare @lMaxSeqn int,
		@seqn int,
		@sortcount int,
		@part varchar(30),
		@lastpart varchar(30);

	create table #ConfigCategory
	(
		SEQN int identity(1,1),
		ORIG_SEQN int,
		PAGEPART varchar(30),
		SORT int,
		ORIG_SORT int
	);

	insert #ConfigCategory (ORIG_SEQN, PAGEPART, SORT, ORIG_SORT)
		select SEQN, PAGEPART, 0, SORT_POSITION
		from dbo.Config_Custom_Web
		order by ID, PAGEPART, SORT_POSITION, SEQN;

	select @lMaxSeqn = max(SEQN)
		from #ConfigCategory;

	set @lastpart = '.';	-- Value not normally found in pagepart
	set @sortcount = 10;

	declare sortposition_cursor cursor fast_forward
	for
	select SEQN, PAGEPART
		from #ConfigCategory
		where ORIG_SORT != 0
			order by PAGEPART, ORIG_SORT;

	open sortposition_cursor;
	fetch next from sortposition_cursor
		into @seqn, @part;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			if @part != @lastpart
			begin
				set @sortcount = 10;
				set @lastpart = @part;
			end;

			update #ConfigCategory
				set SORT = @sortcount
				where SEQN = @seqn;

			set @sortcount = @sortcount + 10;
		end;
		fetch next from sortposition_cursor
			into @seqn, @part;
	end;
	close sortposition_cursor;
	deallocate sortposition_cursor;

	if exists (select 1 from #ConfigCategory where SEQN != ORIG_SEQN or SORT != ORIG_SORT or SEQN > @lMaxSeqn)
	begin
		begin transaction;

		update dbo.Counter
			set LAST_VALUE = @lMaxSeqn,
				UPDATED_BY = 'pr_wv_SortCCW',
				LAST_UPDATED = getdate()
			where COUNTER_NAME = 'Config_Custom_Web';

		update cw
			set SEQN = cc.SEQN,
				SORT_POSITION = cc.SORT
			from #ConfigCategory cc
			join dbo.Config_Custom_Web cw
				on cw.SEQN = cc.ORIG_SEQN
			where (cc.SEQN != cc.ORIG_SEQN or cc.SORT != cc.ORIG_SORT);

		commit transaction;
	end;
end;
go
grant execute on dbo.pr_wv_SortCCW to IMIS;
go

print '-- vr_AllRelationships';
go
if object_id('vr_AllRelationships') is NULL
begin
	exec ('create /* model */ view vr_AllRelationships as select 1 as x;');
end;
go
alter view dbo.vr_AllRelationships
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
select ID, RELATION_TYPE, TARGET_ID, TARGET_NAME, TARGET_RELATION_TYPE, TITLE, FUNCTIONAL_TITLE, STATUS,
	EFFECTIVE_DATE, THRU_DATE, LAST_STRING, DATE_ADDED, LAST_UPDATED, UPDATED_BY, GROUP_CODE, SEQN, 'f' 'DIRECTION'
	from dbo.Relationship
union
select TARGET_ID, TARGET_RELATION_TYPE, ID, '', RELATION_TYPE, TITLE, FUNCTIONAL_TITLE, STATUS,
	EFFECTIVE_DATE, THRU_DATE, LAST_STRING, DATE_ADDED, LAST_UPDATED, UPDATED_BY, GROUP_CODE, SEQN, 'r'
	from dbo.Relationship
	where TARGET_ID > '';
go
grant select, insert, update, delete, references, view definition on dbo.vr_AllRelationships to IMIS;
grant select on dbo.vr_AllRelationships to public;
go


print 'Creating view vr_wv_CurrentConfiguration';
go
if object_id('vr_wv_CurrentConfiguration') is NULL
begin
	exec ('create /* model */ view vr_wv_CurrentConfiguration as select 1 as x;');
end
go
alter view dbo.vr_wv_CurrentConfiguration
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner 
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
-- Returns all rows from CCW that belong to the current config owner, a known table, and CCW_PAGEPART
select ccw.ID, ccw.SEQN, ccw.DEMOG_TABLE_NAME, ccw.FIELD_NAME, ccw.FIELD_REQUIRED, ccw.CUSTOM_CSS,
		ccw.DESCRIPTION_BEFORE, ccw.DESCRIPTION_AFTER, ccw.PAGEPART, ccw.PROMPT, ccw.SHOW_IN_GRID, ccw.SORT_POSITION,
		ccw.ROLES_REQUIRED_EDIT, ccw.ROLES_REQUIRED_EDIT_NEW, ccw.ROLES_REQUIRED_VIEW, ccw.ROLES_REQUIRED_VIEW_NEW,
		ccw.TOOLTIP, ccw.VALIDATION_TABLE, ccw.VALIDATION_TYPE, ccw.DEFAULT_VALUE_FUNCTION, ccw.ALLOW_MARKUP,
		ccw.RANGE_MINIMUM, ccw.RANGE_MAXIMUM, ccw.NUMERIC_INCREMENT, udt.EDIT_TYPES
	from dbo.Config_Custom_Web ccw
	join dbo.Gen_Tables gt
		on gt.CODE = ccw.PAGEPART
	join dbo.SystemConfig sc
		on sc.ParameterValue = ccw.ID
	join dbo.UD_Table udt
		on udt.TABLE_NAME = ccw.DEMOG_TABLE_NAME
	where gt.TABLE_NAME = 'CCW_PAGEPART'
		and udt.ALLOW_MULTIPLE_INSTANCES = 1
		and sc.SystemConfigKey = '19CD1A2C-10B8-4C19-854D-81E2473C1BC1'
go
grant select, insert, update, delete, references, view definition on vr_wv_CurrentConfiguration to IMIS;
grant select on vr_wv_CurrentConfiguration to public;
go


print '-- pr_wv_SaveRelationship';
go
if object_id('pr_wv_SaveRelationship') is NULL
begin
	exec ('create /* model */ procedure pr_wv_SaveRelationship as set nocount on;');
end;
go
alter procedure pr_wv_SaveRelationship
	@lSeqn int = 0,
	@sId varchar(10),
	@sRelationType varchar(10),
	@sTargetId varchar(10),
	@sTargetName varchar(60),
	@sTargetRelationType varchar(10),
	@sTitle varchar(80),
	@sFunctionalTitle varchar(50),
	@sStatus varchar(5),
	@xEffectiveDate datetime,
	@xThruDate datetime,
	@tNote text,
	@sUser varchar(15),
	@sGroupCode varchar(30)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@sReturnMessage varchar(255),	-- output message, may be blank on success
		@xToday datetime,	-- Precalculated today's date with no time component
		@sOldId varchar(10),
		@sOldTargetId varchar(10),
		@sTemp varchar(10);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = 0;	-- Assume success
	set @sReturnMessage = 'no error reported';
	set @xToday = convert(datetime, convert(varchar, getdate(), 112));

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	if @sRelationType = ''
	begin
		set @lReturnValue = -1;
		set @sReturnMessage = 'Relationship type required.';
		goto finish;
	end;

	if @sTargetRelationType = ''
	begin
		set @lReturnValue = -2;
		set @sReturnMessage = 'Target relationship type required.';
		goto finish;
	end;

	if @sTargetId = '' and @sTargetName = ''
	begin
		set @lReturnValue = -3;
		set @sReturnMessage = 'Relationship must have target ID or target name.';
		goto finish;
	end;

	-----------------------------------
	-- Populate worktables with target data
	-----------------------------------

	if ltrim(@sUser) = ''
	begin
		set @sUser = user_name();
	end;

	-----------------------------------
	-- Apply data changes
	-----------------------------------

	if @lSeqn = 0
	begin
		update dbo.Counter
			set LAST_VALUE = LAST_VALUE + 1,
				@lSeqn = LAST_VALUE + 1,
				LAST_UPDATED = getdate(),
				UPDATED_BY = @sUser
			where COUNTER_NAME = 'Relationship';

		insert dbo.Relationship (SEQN, ID, RELATION_TYPE, TARGET_ID, TARGET_NAME, TARGET_RELATION_TYPE,
				TITLE, FUNCTIONAL_TITLE, STATUS, EFFECTIVE_DATE, THRU_DATE, NOTE, DATE_ADDED,
				UPDATED_BY, GROUP_CODE)
			values (@lSeqn, @sId, @sRelationType, @sTargetId, @sTargetName, @sTargetRelationType,
				@sTitle, @sFunctionalTitle, @sStatus, @xEffectiveDate, @xThruDate, @tNote, @xToday,
				@sUser, @sGroupCode);

		set @lReturnValue = @lSeqn;
	end
	else
	begin
		select @sOldId = ID,
				@sOldTargetId = TARGET_ID
			from dbo.Relationship r
			where SEQN = @lSeqn;

		-- if the old relationship had id/target reversed, then swap around.
		if (@sOldId != @sId and @sOldTargetId = @sId and @sTargetId != '')
		begin
			set @sTemp = @sId;
			set @sId = @sTargetId;
			set @sTargetId = @sTemp;

			set @sTemp = @sRelationType;
			set @sRelationType = @sTargetRelationType;
			set @sTargetRelationType = @sTemp;

			-- target name is no longer valid after reversing
			set @sTargetName = '';
		end;

		update dbo.Relationship
			set ID = @sId,
				RELATION_TYPE = @sRelationType,
				TARGET_ID = @sTargetId,
				TARGET_NAME = @sTargetName,
				TARGET_RELATION_TYPE = @sTargetRelationType,
				TITLE = @sTitle,
				FUNCTIONAL_TITLE = @sFunctionalTitle,
				STATUS = @sStatus,
				EFFECTIVE_DATE = @xEffectiveDate,
				THRU_DATE = @xThruDate,
				NOTE = @tNote,
				LAST_UPDATED = @xToday,
				UPDATED_BY = @sUser,
				GROUP_CODE = @sGroupCode
			where SEQN = @lSeqn;

		set @lReturnValue = @lSeqn;
	end;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	select @lReturnValue 'RETURN_VALUE', @sReturnMessage 'RETURN_MESSAGE';

	return @lReturnValue;
end;
go
grant execute on dbo.pr_wv_SaveRelationship to IMIS;
go


-- TODO Move fr_wv_RecordCanAddPage to McGladrey.Library?
print '-- fr_wv_RecordCanAddPage';
go
if object_id('fr_wv_RecordCanAddPage') is NULL
begin
	exec ('create /* model */ function fr_wv_RecordCanAddPage() returns int as begin return 1; end;');
end;
go
alter function fr_wv_RecordCanAddPage
	(@sSelectedID varchar(10),
	@sPagePart varchar(30))
	returns varchar(10)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	declare @sReturn varchar(10),
			@sPrimaryTable varchar(30),
			@sEditType varchar(100),
			@bAllowEdit bit;

	set @bAllowEdit = 0;
	set @sEditType = '';

	select @sPrimaryTable = SUBSTITUTE
		from dbo.Gen_Tables
		where TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			and CODE = @sPagePart;

	select @sEditType = EDIT_TYPES
		from dbo.UD_Table
		where TABLE_NAME = @sPrimaryTable;

	if @sEditType = ''
	begin
		set @bAllowEdit = 1;
	end
	else
	begin
		select @bAllowEdit = 1
			from dbo.fr_ListToRows(@sEditType) ltr
			join dbo.Name n
				on rtrim(ltrim(ltr.VALUE)) = n.MEMBER_TYPE
			where n.ID = @sSelectedID;
	end;

	return @bAllowEdit;
end;
go
grant execute, references, view definition on dbo.fr_wv_RecordCanAddPage to IMIS;
go

print '-- pr_wv_InsertSelectorDetail';
go
if object_id('pr_wv_InsertSelectorDetail') is NULL
begin
	exec ('create /* model */ procedure pr_wv_InsertSelectorDetail as set nocount on;');
end;
go
alter procedure pr_wv_InsertSelectorDetail
	@plPageKey int,
	@psPageCode varchar(30)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set nocount on;

	declare @sGuid varchar(36);

	-- clean out records over a day old
	delete dbo.tr_wv_SelectorDetail
		where DATE_ADDED < dateadd(day, -1, getdate());

	set @sGuid = newid();

	insert dbo.tr_wv_SelectorDetail (DETAIL_KEY, PAGE_KEY, PAGE_CODE)
		values(@sGuid, @plPageKey, @psPageCode);

	select @sGuid 'CURRENT_GUID';

	return 0;
end;
go
grant execute, view definition on dbo.pr_wv_InsertSelectorDetail to IMIS;
go


print '-- pr_wv_UnmetRequirements';
go
if object_id('pr_wv_UnmetRequirements') is NULL
begin
	exec ('create /* model */ procedure pr_wv_UnmetRequirements as set nocount on;');
end;
go
alter procedure pr_wv_UnmetRequirements
	@psLoggedInID varchar(10),
	@psSelectedID varchar(10),
	@psPageCode varchar(30),
	@plPageKey int,
	@pbIsNew bit
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set nocount on;

	declare
		@sTableName varchar(30),
		@sFieldName varchar(30),
		@sFieldType varchar(10),
		@sRolesView varchar(255),
		@sRolesEdit varchar(255),
		@sSelector varchar(50),
		@bViewable bit,
		@bEditable bit,
		@sSQL nvarchar(max),
		@unmet bit;

	declare @UserRoles table
	(
		Role nvarchar(50)
	);

	create table #UnmetReq
	(
		UNMET_REQ bit
	);

	insert #UnmetReq (UNMET_REQ)
		values (0);

	select @sSelector = dbo.fr_wv_SeqnToSelector(@plPageKey, @psPageCode);

	insert @UserRoles (Role)
		select rm.Name
		from dbo.RoleMain rm
		join dbo.UserRole ur
			on ur.RoleKey = rm.RoleKey
		join dbo.UserMain um
			on um.UserKey = ur.UserKey
		where um.ContactMaster = @psLoggedInID;

	declare @tSingleInstance table (TABLE_NAME varchar(30));

	insert @tSingleInstance (TABLE_NAME)
		select distinct TABLE_NAME
		from dbo.UD_Field
		where FIELD_NAME = 'SELECTOR_SINGLE';

	set @sSQL = '';

	if @pbIsNew = 1
	begin
		declare field_cursor cursor fast_forward
		for
		select vccw.DEMOG_TABLE_NAME, vccw.FIELD_NAME, udf.FIELD_TYPE, vccw.ROLES_REQUIRED_VIEW_NEW, 
				vccw.ROLES_REQUIRED_EDIT_NEW
			from dbo.vr_wv_CurrentConfiguration vccw
			join dbo.UD_Field udf
				on udf.TABLE_NAME = vccw.DEMOG_TABLE_NAME
				and udf.FIELD_NAME = vccw.FIELD_NAME
			where vccw.PAGEPART like @psPageCode + '.%'
				and vccw.SORT_POSITION > 0
				and vccw.FIELD_REQUIRED = 1
				and vccw.VALIDATION_TYPE != 'SQLFUNCTION'
				and vccw.DEMOG_TABLE_NAME in (select si.TABLE_NAME from @tSingleInstance si)
			order by vccw.DEMOG_TABLE_NAME;
	end
	else
	begin
		declare field_cursor cursor fast_forward
		for
		select vccw.DEMOG_TABLE_NAME, vccw.FIELD_NAME, udf.FIELD_TYPE, vccw.ROLES_REQUIRED_VIEW,
				vccw.ROLES_REQUIRED_EDIT
			from dbo.vr_wv_CurrentConfiguration vccw
			join dbo.UD_Field udf
				on udf.TABLE_NAME = vccw.DEMOG_TABLE_NAME
				and udf.FIELD_NAME = vccw.FIELD_NAME
			where vccw.PAGEPART like @psPageCode + '.%'
				and vccw.SORT_POSITION > 0
				and vccw.FIELD_REQUIRED = 1
				and vccw.VALIDATION_TYPE != 'SQLFUNCTION'
				and vccw.DEMOG_TABLE_NAME in (select si.TABLE_NAME from @tSingleInstance si)
			order by vccw.DEMOG_TABLE_NAME;
	end;
	
	open field_cursor;
	fetch next from field_cursor
		into @sTableName, @sFieldName, @sFieldType, @sRolesView, @sRolesEdit;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			set @bViewable = 0;
			set @bEditable = 0;

			if @sRolesView = ''
			begin
				set @bViewable = 1;
			end
			else
			begin
				select @bViewable = 1
					from @UserRoles ur
					join dbo.fr_ListToRows(@sRolesView) ltr
						on ur.Role = rtrim(ltrim(ltr.VALUE));
			end;

			if @bViewable = 1
			begin
				if @sRolesEdit = ''
				begin
					set @bEditable = 1;
				end;
				else
				begin
					select @bEditable = 1
						from @UserRoles ur
						join dbo.fr_ListToRows(@sRolesEdit) ltr
							on ur.Role = rtrim(ltrim(ltr.VALUE));
				end;
			end;

			if @bEditable = 1
			begin
				set @sSQL = @sSQL + 'update #UnmetReq set UNMET_REQ = 1 from dbo.[' + @sTableName 
						+ '] where ID = @id and SELECTOR_SINGLE = @selector' 

				if @sFieldType = 'Char'
				begin
					set @sSQL = @sSQL + ' and convert(varchar(max), [' + @sFieldName + ']) = '''';';
				end;
				else if @sFieldType in ('Date', 'DateTime')
				begin
					set @sSQL = @sSQL + ' and ([' + @sFieldName + '] is null or convert(date, [' + @sFieldName 
						+ ']) = ''19000101'');';
				end;
				else if @sFieldType = 'Time'
				begin
					set @sSQL = @sSQL + ' and ([' + @sFieldName + '] is null or datepart(hour, [' + @sFieldName 
						+ ']) = 0 and datepart(minute, [' + @sFieldName + ']) = 0);';
				end;
				else if @sFieldType in ('Int', 'Money', 'Number', 'CheckBox')
				begin
					set @sSQL = @sSQL + ' and [' + @sFieldName + '] = 0;';
				end;
				else
				begin
					-- Can't validate any other types, so allow the test to succeed
					set @sSQL = @sSQL + ' and 1 = 0;'
				end			
			end;
		end;
		fetch next from field_cursor
			into @sTableName, @sFieldName, @sFieldType, @sRolesView, @sRolesEdit;
	end;
	close field_cursor;
	deallocate field_cursor;

	if @sSQL != ''
	begin
		exec sp_executesql @sSQL, N'@id varchar(10), @selector varchar(50)', @psSelectedID, @sSelector;
	end

finish:
	select @unmet = UNMET_REQ
		from #UnmetReq;

	return @unmet;
end;
go
grant execute, view definition on dbo.pr_wv_UnmetRequirements to IMIS;
go

print '-- pr_wv_WriteLog';
go
if object_id('pr_wv_WriteLog') is NULL
begin
	exec ('create /* model */ procedure pr_wv_WriteLog as set nocount on;');
end;
go
alter procedure pr_wv_WriteLog
	@level int,
	@message varchar(8000)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set nocount on;

	declare @maxLevel int,
		@maxLevelStr varchar(255);

	set @maxLevel = 3;	-- fallback value

	if exists (select 1 from dbo.sysobjects where name = 'SystemConfig')
	begin
		select @maxLevelStr = ParameterValue
			from dbo.SystemConfig
			where ParameterName = 'RSM.Common.LogLevel';

		if @@rowcount != 0
		begin
			if isnumeric(@maxLevelStr) = 1
			begin
				set @maxLevel = convert(int, @maxLevelStr);
			end;
		end;
	end;

	if @maxLevel < 0 or @maxLevel > 5
	begin
		set @maxLevel = 3;
	end;

	if @level <= @maxlevel
	begin
		insert dbo.tr_wv_Log (CONFIG_LOG_LEVEL, CURRENT_LOG_LEVEL, LOG_TEXT)
			values (@maxLevel, @level, @message);
	end;
end;
go
grant execute, view definition on dbo.pr_wv_WriteLog to public;
go

print 'Creating procedure pr_wv_SetDefaultValues';
go
if object_id('pr_wv_SetDefaultValues') is NULL
begin
	exec ('create /* model */ procedure pr_wv_SetDefaultValues as set nocount on;');
end;
go
alter procedure pr_wv_SetDefaultValues
	@newSeqn int,
	@id varchar(10),
	@thisTable varchar(30),
	@page varchar(30),
	@debug bit = 0
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@cmd nvarchar(4000),
		@field varchar(30),
		@formula varchar(100);

	set @lReturnValue = 0;	-- Assume success

	declare FieldsWithDefault_cursor cursor fast_forward
	for
	select distinct vccw.FIELD_NAME, vccw.DEFAULT_VALUE_FUNCTION
		from dbo.vr_wv_CurrentConfiguration vccw
		where vccw.DEMOG_TABLE_NAME = @thisTable
			and vccw.PAGEPART like @page + '.%'
			and vccw.DEFAULT_VALUE_FUNCTION != ''
			and vccw.SORT_POSITION > 0
		order by vccw.FIELD_NAME;

	open FieldsWithDefault_cursor;
	fetch next from FieldsWithDefault_cursor
		into @field, @formula;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			if @formula not like '%.%'
			begin
				set @formula = 'dbo.' + @formula;
			end;

			set @cmd = N'update dbo.' + quotename(@thisTable)
				+ N' set ' + quotename(@field) + N' = ' + @formula + N'(SEQN)'
				+ N' where SEQN = @paramSeqn and ID = @paramId';

			if @debug = 1
			begin
				print @cmd;
			end;

			exec dbo.sp_executesql @cmd,
				N'@paramSeqn int, @paramId varchar(10)',
				@paramSeqn = @newSeqn, @paramId = @id;
			
			set @lReturnValue = @lReturnValue + 1;
		end;
		fetch next from FieldsWithDefault_cursor
			into @field, @formula;
	end;
	close FieldsWithDefault_cursor;
	deallocate FieldsWithDefault_cursor;
		
	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_SetDefaultValues to IMIS;
grant execute, view definition on dbo.pr_wv_SetDefaultValues to public;
go


print 'Creating procedure pr_wv_InternalCreateInstance';
go
if object_id('pr_wv_InternalCreateInstance') is NULL
begin
	exec ('create /* model */ procedure pr_wv_InternalCreateInstance as set nocount on;');
end;
go
alter procedure pr_wv_InternalCreateInstance
	@id varchar(10),
	@byUser varchar(60),
	@pagePart varchar(30),
	@thisTable varchar(30),
	@isPrimaryTable bit,
	@newSelector varchar(50),
	@currentSelector varchar(50),
	@selectorType varchar(10),
	@debug bit,
	@insertLogging bit
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @newSeqn int,
		@cmd nvarchar(4000),
		@newSubStatus varchar(60),
		@page varchar(30),
		@extraFields nvarchar(1000),
		@extraValues nvarchar(1000),
		@extraLogText nvarchar(1000);

	insert dbo.Counter (COUNTER_NAME, LAST_VALUE, HAS_CHECKSUM)
		select @thisTable, 0, 0
		where not exists (select 1 from dbo.Counter where COUNTER_NAME = @thisTable);
	
	set @newSeqn = 0;
	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	set @extraFields = N'';
	set @extraValues = N'';
	set @extraLogText = N'';
	
	if exists (select 1
		from dbo.UD_Field udf
		where udf.TABLE_NAME = @thisTable
			and udf.FIELD_NAME = 'WV_CREATED_DATE'
			and udf.FIELD_TYPE in ('DateTime', 'Date'))
	begin
		set @extraFields = @extraFields + N', WV_CREATED_DATE';
		set @extraValues = @extraValues + N', getdate()';
	end
	
	if exists (select 1
		from dbo.UD_Field udf
		where udf.TABLE_NAME = @thisTable
			and udf.FIELD_NAME = 'WV_CREATED_BY'
			and udf.FIELD_TYPE = 'Char'
			and udf.FIELD_LENGTH >= 60)
	begin
		set @extraFields = @extraFields + N', WV_CREATED_BY';
		set @extraValues = @extraValues + N', @paramLoggedInUser';
	end

	if @selectorType = 'SINGLE'
		and @isPrimaryTable = 1
		and exists (select 1
			from dbo.UD_Field udf
			where udf.TABLE_NAME = @thisTable
				and udf.FIELD_NAME = 'SUBMISSION_STATUS'
				and udf.FIELD_TYPE = 'Char'
				and udf.FIELD_LENGTH >= 20)
	begin	
		-- Set SUBMISSION_STATUS to first item in lookup if present
		select @newSubStatus = min(gt.CODE)
			from dbo.Gen_Tables gt
			join dbo.vr_wv_CurrentConfiguration vccw
				on vccw.VALIDATION_TABLE = gt.TABLE_NAME
			where vccw.DEMOG_TABLE_NAME = @thisTable
				and vccw.FIELD_NAME = 'SUBMISSION_STATUS'
				and vccw.VALIDATION_TABLE != ''
				and gt.CODE != '';

		if isnull(@newSubStatus, '') != ''
		begin
			set @extraFields = @extraFields + N', SUBMISSION_STATUS';
			set @extraValues = @extraValues + N', @paramSubmissionStatus';
			set @extraLogText = @extraLogText + N' + ''; SUBMISSION_STATUS -> '' + @paramSubmissionStatus';
		end
	end

	if @selectorType = 'SINGLE'
	begin
		set @cmd = N'
if not exists (select 1 from dbo.' + quotename(@thisTable) + N' where ID = @paramId and SELECTOR_SINGLE = @paramMySelector and SELECTOR_PARENT = @paramParentSelector)
begin
  update dbo.Counter
    set LAST_VALUE = LAST_VALUE + 1,
      @paramSeqn = LAST_VALUE + 1,
      LAST_UPDATED = getdate(),
      UPDATED_BY = ''CreateInstance''
      where COUNTER_NAME = ''' + @thisTable + N''';
  insert dbo.' + quotename(@thisTable) + N' (ID, SEQN, SELECTOR_SINGLE, SELECTOR_PARENT' + @extraFields + ')
    select @paramId, @paramSeqn, @paramMySelector, @paramParentSelector' + @extraValues + '
    where not exists (select 1 from dbo.' + quotename(@thisTable) + N' where ID = @paramId and SELECTOR_SINGLE = @paramMySelector and SELECTOR_PARENT = @paramParentSelector);
  insert dbo.Name_Log (DATE_TIME, LOG_TYPE, SUB_TYPE, USER_ID, ID, LOG_TEXT)
    select getdate(), ''CHANGE'', ''ADD'', @paramloggedInUser, @paramId, ''' +  @thisTable + N': SEQN -> '' + ' +
      N'convert(varchar, @paramSeqn) + ''; SELECTOR_SINGLE -> '' + @paramMySelector + ''; SELECTOR_PARENT -> '' + @paramParentSelector'
      + @extraLogText + N'
    where @paraminsertLogging = 1 and @@rowcount = 1;
end;';

		if @debug = 1
		begin
			print @cmd;
		end;

		exec dbo.sp_executesql @cmd,
			N'@paramId varchar(10), @paramSeqn int output, @paramMySelector varchar(50), @paramParentSelector varchar(50), @paramLoggedInUser varchar(60), @paramInsertLogging bit, @paramSubmissionStatus varchar(60)',
			@paramId = @id, @paramSeqn = @newSeqn output, @paramMySelector = @newSelector, 
			@paramParentSelector = @currentSelector, @paramLoggedInUser = @byUser, 
			@paramInsertLogging = @insertLogging, @paramSubmissionStatus = @newSubStatus;
	end
	else if @selectorType = 'MULTI'
	begin
		set @cmd = N'
  update dbo.Counter
    set LAST_VALUE = LAST_VALUE + 1,
      @paramSeqn = LAST_VALUE + 1,
      LAST_UPDATED = getdate(),
      UPDATED_BY = ''CreateInstance''
      where COUNTER_NAME = ''' + @thisTable + N'''
  insert dbo.' + quotename(@thisTable) + N' (ID, SEQN, SELECTOR_MULTI, SELECTOR_PARENT' + @extraFields + ')
    select @paramId, @paramSeqn, @paramMySelector, @paramParentSelector' + @extraValues;

		if @debug = 1
		begin
			print @cmd;
		end;

		exec dbo.sp_executesql @cmd,
			N'@paramId varchar(10), @paramSeqn int output, @paramMySelector varchar(50), @paramParentSelector varchar(50), @paramLoggedInUser varchar(60)',
			@paramId = @id, @paramSeqn = @newSeqn output, @paramMySelector = @newSelector, @paramParentSelector = @currentSelector, @paramLoggedInUser = @byUser;
	end
	else if @selectorType = 'SIMPLE'
	begin
		set @cmd = N'
update dbo.Counter
  set LAST_VALUE = LAST_VALUE + 1,
    @paramSeqn = LAST_VALUE + 1,
    LAST_UPDATED = getdate(),
    UPDATED_BY = ''CreateInstance''
  where COUNTER_NAME = ''' + @thisTable + N'''
insert dbo.' + quotename(@thisTable) + N' (ID, SEQN' + @extraFields + ')
  select @paramId, @paramSeqn' + @extraValues + '
  where not exists (select 0 from dbo.' + quotename(@thisTable) + N' where ID = @paramId and SEQN = @paramSeqn)';

		if @debug = 1
		begin
			print @cmd;
		end;

		exec dbo.sp_executesql @cmd,
			N'@paramId varchar(10), @paramSeqn int output, @paramLoggedInUser varchar(60)',
			@paramId = @id, @paramSeqn = @newSeqn output, @paramLoggedInUser = @byUser;
	end;
	
	if @newSeqn > 0
	begin
		exec dbo.pr_wv_SetDefaultValues @newSeqn, @id, @thisTable, @page, @debug;
	end
	else if @newSeqn = 0
	begin
		set @newSeqn = -20;
	end;

finish:
	return @newSeqn;
end;
go
grant execute, view definition on dbo.pr_wv_InternalCreateInstance to IMIS;
grant execute, view definition on dbo.pr_wv_InternalCreateInstance to public;
go



print 'Creating procedure pr_wv_CreateInstance';
go
if object_id('pr_wv_CreateInstance') is NULL
begin
	exec ('create /* model */ procedure pr_wv_CreateInstance as set nocount on;');
end;
go
alter procedure pr_wv_CreateInstance
	@id varchar(10),
	@pagePart varchar(30),
	@newSelector varchar(50),
	@currentPageKey int,
	@currentPageCode varchar(30),
	@debug bit = 0,
	@byUser varchar(60) = '',
	@insertLogging bit = 0
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@xToday datetime,	-- Precalculated today's date with no time component
		@page varchar(30),
		@keyTable varchar(30),
		@isKeyTable bit,
		@currentSelector varchar(50),
		@thisTable varchar(30),
		@newSeqn int,
		@cmd nvarchar(4000),
		@newSubStatus varchar(30),
		@keySeqn int,
		@sCustomCmd nvarchar(1000);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = 0; -- Assume failure
	set @xToday = convert(datetime, convert(varchar, getdate(), 112));
	set @keySeqn = -1;

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	select @keyTable = dbo.fr_wv_PagePrimaryTable(@page);

	if @@rowcount != 1
	begin
		set @lReturnValue = -10;
		goto finish;
	end;

	set @currentSelector = '';

	if @currentPageKey > 0
	begin
		select @currentSelector = dbo.fr_wv_SeqnToSelector(@currentPageKey, @currentPageCode);

		if @currentSelector = ''
		begin
			set @lReturnValue = -15;
			goto finish;
		end;
	end;
	
	-----------------------------------
	-- Iterate over applicable tables
	-----------------------------------
	declare pageTables_cursor cursor fast_forward
	for
	select distinct vccw.DEMOG_TABLE_NAME, case vccw.DEMOG_TABLE_NAME when @keyTable then 1 else 0 end 'IsKeyTable'
		from dbo.vr_wv_CurrentConfiguration vccw
		join dbo.UD_Field uf
			on uf.TABLE_NAME = vccw.DEMOG_TABLE_NAME
		join dbo.UD_Field ufp
			on ufp.TABLE_NAME = vccw.DEMOG_TABLE_NAME
		where vccw.PAGEPART like @page + '.%'
			and uf.FIELD_NAME = 'SELECTOR_SINGLE'
			and ufp.FIELD_NAME = 'SELECTOR_PARENT'
		order by vccw.DEMOG_TABLE_NAME;

	open pageTables_cursor;
	fetch next from pageTables_cursor
		into @thisTable, @isKeyTable;

	while @@fetch_status <> -1
	begin
		if @@fetch_status = 0
		begin
			exec @newSeqn = dbo.pr_wv_InternalCreateInstance @id, @byUser, @pagePart, @thisTable, @isKeyTable, 
					@newSelector, @currentSelector, 'SINGLE', @debug, @insertLogging;

			if @newSeqn < 0 and @lReturnValue = 0
			begin
				set @lReturnValue = @newSeqn;
			end;
			else if @isKeyTable = 1
			begin
				set @keySeqn = @newSeqn;
			end;
		end;
		fetch next from pageTables_cursor
			into @thisTable, @isKeyTable;
	end;
	close pageTables_cursor;
	deallocate pageTables_cursor;

	if exists (select 1 from sys.procedures where name = 'pr_wv_CreateInstance_Custom')
	begin
		set @sCustomCmd = N'exec dbo.pr_wv_CreateInstance_Custom @paramid, @paramPagePart,'
						+ N' @paramNewPageKey, @paramCurrentPageKey, @paramCurrentPageCode, @paramDebug, '
						+ N' @paramLoggedInUser, @paramInsertLogging, @paramSelector';

		if @debug = 1
		begin
			print @sCustomCmd;
		end;

		exec dbo.sp_executesql @sCustomCmd,
			N'@paramid varchar(10), @paramPagePart varchar(30), @paramNewPageKey int, @paramCurrentPageKey int, @paramCurrentPageCode varchar(30), @paramDebug bit, @paramLoggedInUser varchar(60), @paramInsertLogging bit, @paramSelector varchar(50)',
			@paramid = @id, @paramPagePart = @pagePart, @paramNewPageKey = @keySeqn,
			@paramCurrentPageKey = @currentPageKey, @paramCurrentPageCode = @currentPageCode,
			@paramDebug = @debug, @paramLoggedInUser = @byUser, @paramInsertLogging = @insertLogging,
			@paramSelector = @newSelector;
	end;

	if @lReturnValue = 0 and @keySeqn >= 0
	begin
		set @lReturnValue = @keySeqn;
	end;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateInstance to IMIS;
grant execute, view definition on dbo.pr_wv_CreateInstance to public;
go


print 'Creating procedure pr_wv_CreateInstanceAutoSelector';
go
if object_id('pr_wv_CreateInstanceAutoSelector') is NULL
begin
	exec ('create /* model */ procedure pr_wv_CreateInstanceAutoSelector as set nocount on;');
end;
go
alter procedure pr_wv_CreateInstanceAutoSelector
	@id varchar(10),
	@pagePart varchar(30),
	@currentPageKey int,
	@currentPageCode varchar(30),
	@debug bit = 0,
	@byUser varchar(60) = '',
	@insertLogging bit = 0
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,
		@page varchar(30),
		@newSelector varchar(50);

	set @lReturnValue = -1;

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	set @newSelector = @page + '.' + replace(newid(), '-', '');
	
	exec @lReturnValue = dbo.pr_wv_CreateInstance @id, @pagePart, @newSelector, @currentPageKey,
			@currentPageCode, @debug, @byUser, @insertLogging;

	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateInstanceAutoSelector to IMIS;
grant execute, view definition on dbo.pr_wv_CreateInstanceAutoSelector to public;
go


print 'Creating procedure pr_wv_CreateMultiInstance';
go
if object_id('pr_wv_CreateMultiInstance') is NULL
begin
	exec ('create /* model */ procedure pr_wv_CreateMultiInstance as set nocount on;');
end;
go
alter procedure pr_wv_CreateMultiInstance
	@id varchar(10),
	@pagePart varchar(30),
	@selector varchar(50),
	@debug bit = 0,
	@byUser varchar(60) = ''
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@thisTable varchar(30),
		@page varchar(30);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = -1;	-- Assume failure

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	select @thisTable = max(vccw.DEMOG_TABLE_NAME)
		from dbo.vr_wv_CurrentConfiguration vccw
		join dbo.UD_Field uf
			on uf.TABLE_NAME = vccw.DEMOG_TABLE_NAME
		where vccw.PAGEPART = @pagePart
			and uf.FIELD_NAME = 'SELECTOR_MULTI';

	if @@rowcount != 1
	begin
		set @lReturnValue = -10;
		goto finish;
	end;
	
	-- Grid type cannot be nested
	exec @lReturnValue = dbo.pr_wv_InternalCreateInstance @id, @byUser, @pagePart, @thisTable, 0, @selector, 
		'', 'MULTI', @debug, 0;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateMultiInstance to IMIS;
grant execute, view definition on dbo.pr_wv_CreateMultiInstance to public;
go

print 'Creating procedure pr_wv_CreateSimpleMultiInstance';
go
if object_id('pr_wv_CreateSimpleMultiInstance') is NULL
begin
	exec ('create /* model */ procedure pr_wv_CreateSimpleMultiInstance as set nocount on;');
end;
go
alter procedure pr_wv_CreateSimpleMultiInstance
	@id varchar(10),
	@pagePart varchar(30),
	@debug bit = 0,
	@byUser varchar(60) = ''
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @lReturnValue int,	-- 0 on success, number indicates error
		@thisTable varchar(30),
		@page varchar(30);

	-----------------------------------
	-- Setup initial values
	-----------------------------------
	set @lReturnValue = -1;	-- Assume failure

	select @page = dbo.fr_BeforeDelimiter(@pagePart, '.');

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	select @thisTable = max(vccw.DEMOG_TABLE_NAME)
		from dbo.vr_wv_CurrentConfiguration vccw
		where vccw.PAGEPART = @pagePart
			and vccw.DEMOG_TABLE_NAME not in (select uf.TABLE_NAME
					from dbo.UD_Field uf
					where uf.FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI'));

	if @@rowcount != 1
	begin
		set @lReturnValue = -10;
		goto finish;
	end;

	-- Simple view does not support nesting or submission status
	exec @lReturnValue = dbo.pr_wv_InternalCreateInstance @id, @byUser, @pagePart, @thisTable, 0, 
		'', '', 'SIMPLE', @debug, 0;

	-----------------------------------
	-- Exit and return status
	-----------------------------------
finish:
	return @lReturnValue;
end;
go
grant execute, view definition on dbo.pr_wv_CreateSimpleMultiInstance to IMIS;
grant execute, view definition on dbo.pr_wv_CreateSimpleMultiInstance to public;
go


print 'Creating procedure pr_wv_UDTableToCCW';
go
if object_id('pr_wv_UDTableToCCW') is NULL
begin
	exec ('create /* model */ procedure pr_wv_UDTableToCCW as set nocount on;');
end;
go
alter procedure pr_wv_UDTableToCCW
	@psUDTable varchar(30),
	@psPagePart varchar(30)
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
-- Generate a new page code and CCW group from a UDT
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	declare @pagecode varchar(30),
		@newpage bit,
		@ownerId varchar(10),
		@primaryTable varchar(30)

	-----------------------------------
	-- Validate inputs
	-----------------------------------

	-- Make sure the lookup contains all known MI UDTs as a courtesy
	insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
		select 'CCW_MULTI_UDTS', udt.TABLE_NAME, upper(udt.TABLE_NAME), udt.TABLE_NAME
		from dbo.UD_Table udt
		where ALLOW_MULTIPLE_INSTANCES = 1
			and udt.TABLE_NAME not in (select CODE from dbo.Gen_Tables where TABLE_NAME = 'CCW_MULTI_UDTS');

	print 'Validating requirements'

	select @ownerId = sc.ParameterValue
		from dbo.SystemConfig sc
		join dbo.Name n
			on n.ID = sc.ParameterValue
		where sc.ParameterName = 'RSM.wvMultiInstance.ConfigurationOwner'
			and n.MEMBER_TYPE = '_CFG'

	if @@rowcount = 0
	begin
		print '*** Error: The Configuration Owner setting is not defined, does not exist, or has the wrong member type.'
		return;
	end

	-- Insert counter if not present
	if not exists (select 1 from dbo.Counter where COUNTER_NAME = 'Config_Custom_Web')
	begin
		insert dbo.Counter (COUNTER_NAME, LAST_VALUE, LAST_UPDATED, UPDATED_BY)
			select 'Config_Custom_Web', 0, getdate(), 'wvSuite'
			where not exists (select 1 from dbo.Counter where COUNTER_NAME = 'Config_Custom_Web')
	end
	
	-- Ensure the counter is correct
	if exists (select 1 from Config_Custom_Web)
	begin
		update dbo.Counter
			set LAST_VALUE = (select max(SEQN) from dbo.Config_Custom_Web where ID = @ownerId)
			where COUNTER_NAME = 'Config_Custom_Web'
	end

	if @psUDTable not in (select CODE from dbo.Gen_Tables where TABLE_NAME = 'CCW_MULTI_UDTS')
	begin
		print '*** Error: @psTable must be a known User-Defined Table that allows multiple instances';
		return;
	end

	-- Normalize the name of the table
	select @psUDTable = udt.TABLE_NAME
		from dbo.UD_Table udt
		where udt.TABLE_NAME = @psUDTable

	if charindex('.', @psPagePart) in (0, 1, len(@psPagePart))
	begin
		print '*** Error: @psPagepart must be of the form PAGE.PART';
		return;
	end;

	set @pagecode = left(@psPagePart, charindex('.', @psPagePart) - 1)

	print 'Populating CCW_PAGEPART'
	if exists (select 1 from dbo.Gen_Tables where TABLE_NAME = 'CCW_PAGEPART' and CODE = @psPagePart)
	begin
		print '-- already contains an entry for PagePart ' + @psPagePart;
	end
	else
	begin
		print '-- adding new PagePart ' + @psPagePart
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, DESCRIPTION)
			values ('CCW_PAGEPART', @psPagePart, upper(@psPagePart), @psUDTable);
	end

	print 'Populating CCW_PAGEPRIMARYTABLE'
	select @primaryTable = SUBSTITUTE
		from dbo.Gen_Tables
		where TABLE_NAME = 'CCW_PAGEPRIMARYTABLE'
			and CODE = @pagecode

	if isnull(@primaryTable, '') != ''
	begin
		print '-- Pagecode ' + @pagecode + ' is already defined with ' + @primaryTable + ' as the primary table.';
		set @newpage = 0
	end
	else
	begin
		print '-- Pagecode ' + @pagecode + ' does not exist.  ' + @psUDTable + ' will be the primary table for this page.';
		set @newpage = 1
		insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE)
			values ('CCW_PAGEPRIMARYTABLE', @pagecode, upper(@pagecode), @psUDTable)
	end

	print 'Populating Config_Custom_Web'
	declare @lastSort int

	if exists (select 1 from dbo.Config_Custom_Web where PAGEPART = @psPagePart)
	begin
		print '-- PagePart ' + @psPagepart + ' is already defined. Adding only new fields.';
		
		select @lastSort = max(SORT_POSITION)
			from dbo.Config_Custom_Web 
			where PAGEPART = @psPagePart;
	end
	else
	begin
		set @lastSort = 0;
	end

	declare @counter_rows int,
		@counter_seqn int;

	declare @udf_numbered table
	(
		SEQN int identity,
		UNIQUE_KEY int not NULL,
		NEW_SEQN int
	);

	insert @udf_numbered (UNIQUE_KEY, NEW_SEQN)
		select SEQ, 0
		from dbo.UD_Field udf
		where udf.TABLE_NAME = @psUDTable
			and udf.FIELD_NAME not in (select FIELD_NAME from dbo.Config_Custom_Web ccw where ccw.PAGEPART = @psPagePart)
		order by SEQ

	select @counter_rows = count(*)
		from @udf_numbered;
		
	if @counter_rows = 0
	begin
		print '*** No new fields found';
		return;
	end

	update dbo.Counter
		set LAST_VALUE = LAST_VALUE + @counter_rows,
			@counter_seqn = LAST_VALUE,
			LAST_UPDATED = getdate(),
			UPDATED_BY = user_name()
		where COUNTER_NAME = 'Config_Custom_Web';

	update xn
		set NEW_SEQN = xn.SEQN + @counter_seqn
		from @udf_numbered xn

	insert dbo.Config_Custom_Web (ID, SEQN, DEMOG_TABLE_NAME, FIELD_NAME, PAGEPART, PROMPT, SORT_POSITION, VALIDATION_TABLE, VALIDATION_TYPE, ROLES_REQUIRED_EDIT, ROLES_REQUIRED_EDIT_NEW)
		select @ownerId, un.NEW_SEQN, @psUDTable, udf.FIELD_NAME, @psPagePart, udf.PROMPT, @lastSort + udf.SEQ * 10, udf.VALIDATION_TABLE,
			-- Flag the field as having a lookup table if defined
			case udf.VALIDATION_TABLE when '' then '' else 'GENTABLE' end,
			-- Selector fields are automatically read-only
			case when udf.FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI', 'SELECTOR_PARENT') then 'NOBODY' else '' end,
			case when udf.FIELD_NAME in ('SELECTOR_SINGLE', 'SELECTOR_MULTI', 'SELECTOR_PARENT') then 'NOBODY' else '' end
		from dbo.UD_Field udf
		join @udf_numbered un
			on udf.SEQ = un.UNIQUE_KEY
		where udf.TABLE_NAME = @psUDTable

	select @counter_rows = count(*)
		from dbo.Config_Custom_Web ccw
		where ccw.PAGEPART = @psPagePart

	print 'Success:  PagePart contains ' + convert(varchar(10), @counter_rows) + ' fields.'
end;
go
grant execute, view definition on dbo.pr_wv_UDTableToCCW to IMIS;
go

print 'Creating procedure pr_wv_DeleteAndLogUpload';
go
if object_id('pr_wv_DeleteAndLogUpload') is NULL
begin
	exec ('create /* model */ procedure pr_wv_DeleteAndLogUpload as set nocount on;');
end;
go
alter procedure pr_wv_DeleteAndLogUpload
	@plPageKey int,
	@psImisId varchar(10),
	@psActivityType varchar(10),
	@pbEnableLogging bit
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner 
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
-- Write a log entry and delete an upload
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;

	if @pbEnableLogging = 1
	begin
		declare @userid varchar(60)
		
		set @userid = @psImisId;
		
		select @userid = um.UserId
			from dbo.UserMain um
			where um.ContactMaster = @psImisId

		insert dbo.Name_Log (DATE_TIME, ID, LOG_TEXT, LOG_TYPE, SUB_TYPE, USER_ID) 
			select getdate(),
				a.ID,
				'FileUpload (' + convert(varchar(10), a.SEQN) + '); File Name: ' + a.UF_3 + '; Attachment Name: ' + a.UF_2 + ' Deleted',
				'CHANGE',
				'DELETE',
				@userid
			from dbo.Activity a
			where a.SEQN = @plPageKey
				and ACTIVITY_TYPE = @psActivityType;
	end

	delete
		from dbo.Activity
		where SEQN = @plPageKey
			and ACTIVITY_TYPE = @psActivityType;
end;
go
grant execute, view definition on pr_wv_DeleteAndLogUpload to IMIS;
go

print 'Creating procedure pr_wv_LogUploadUpdates';
go
if object_id('pr_wv_LogUploadUpdates') is NULL
begin
	exec ('create /* model */ procedure pr_wv_LogUploadUpdates as set nocount on;');
end;
go
alter procedure pr_wv_LogUploadUpdates
	@plPageKey int,
	@psImisId varchar(10),
	@psSourceCode varchar(40),
	@psDescription varchar(255),
	@psUf1 varchar(255),
	@psActivityType varchar(10),
	@pxEffectiveDate datetime,
	@pxThroughDate datetime
as
/***************************************************************************************************
	 2020 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner 
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/bin/Release/wvSuite_Install.3.sql $
$Rev: 15155 $
$Date: 2020-05-26 15:09:22 -0500 (Tue, 26 May 2020) $
***************************************************************************************************/
-- Write intended changes to the Activity record as log entries
begin
	set ansi_defaults on;
	set arithabort on;
	set concat_null_yields_null on;
	set implicit_transactions off;
	set numeric_roundabort off;
	set nocount on;
	
	declare @crlf varchar(2);
	set @crlf = char(13) + char(10)

	insert dbo.Name_Log (DATE_TIME, LOG_TYPE, SUB_TYPE, USER_ID, ID, LOG_TEXT)
		select getdate(), 'CHANGE', 'CHANGE', @psImisId, a.ID,
			'Activity[' + convert(varchar(10), @plPageKey) + ']' + @crlf +
			case
				when SOURCE_CODE != @psSourceCode
					then 'SOURCE_CODE: ' + SOURCE_CODE + ' -> ' + @psSourceCode + ';' + @crlf
					else ''
			end +
			case
				when DESCRIPTION != @psDescription
					then 'DESCRIPTION: ' + DESCRIPTION + ' -> ' + @psDescription + ';' + @crlf
					else ''
			end +
			case
				when UF_1 != @psUf1
					then 'UF_1: ' + UF_1 + ' -> ' + @psUf1 + ';' + @crlf
					else ''
			end	+
			case
				when UF_6 != @pxEffectiveDate 
						or (UF_6 is NULL and @pxEffectiveDate is not NULL)
						or (UF_6 is not NULL and @pxEffectiveDate is NULL)
					then 'UF_6: ' + isnull(convert(varchar(23), UF_6, 121), 'null') + ' -> ' + isnull(convert(varchar(23), @pxEffectiveDate, 121), 'null') + ';' + @crlf
					else ''
			end	+
			case
				when UF_7 != @pxThroughDate
						or (UF_7 is NULL and @pxThroughDate is not NULL)
						or (UF_7 is not NULL and @pxThroughDate is NULL)
					then 'UF_7: ' + isnull(convert(varchar(23), UF_7, 121), 'null') + ' -> ' + isnull(convert(varchar(23), @pxThroughDate, 121), 'null') + ';' + @crlf
					else ''
			end
		from dbo.Activity a
		where a.SEQN = @plPageKey
			and ACTIVITY_TYPE = @psActivityType
			and (a.SOURCE_CODE != @psSourceCode
				or a.DESCRIPTION != @psDescription
				or a.UF_1 != @psUf1
				or a.UF_6 != @pxEffectiveDate
				or (UF_6 is NULL and @pxEffectiveDate is not NULL)
				or (UF_6 is not NULL and @pxEffectiveDate is NULL)
				or a.UF_7 != @pxThroughDate
				or (UF_7 is NULL and @pxThroughDate is not NULL)
				or (UF_7 is not NULL and @pxThroughDate is NULL));
end;
go
grant execute, view definition on pr_wv_LogUploadUpdates to IMIS;
go

go
print '';
print @@servername + ':' + db_name() + ' - finished at ' + convert(varchar(30), getdate(), 109);
print '';
go